<?php 

include 'config.php';

session_start();

if(empty($_SESSION['me'])){
	header('Location: index.php');
	exit;
}

$acao = empty($_POST['acao']) ? '' : $_POST['acao'];
$lastTime = empty($_SESSION['last']) ? 0 : $_SESSION['last'];

if(!empty($acao)){
	switch($acao){
		case 'update':
			$user = new Usuario();
			$user->codusuario = $_SESSION['me']['codusuario'];
			$user->ultimaAtividade = time();
			$user->save();
			$user->reset();
			
			Usuario::limparUsuariosInativos();
			
			$user->where('{codsala} = ? AND {codusuario} != ?', $_SESSION['me']['codsala'], $_SESSION['me']['codusuario'])
				->order('apelido')
				->find();
			
			$chat = new Chat();
			$total = $chat->alias('c')
				->where('c.para = ?', $_SESSION['me']['codusuario'])
				->where('c.codsala = ?', $_SESSION['me']['codsala'])
				->where('c.dtahr > ?', $lastTime)
				->find();
			
			$resp['buddies'] = $user->allToArray();
			$resp['msg'] = $chat->allToArray();
			
			if($total > 0){
				$_SESSION['last'] = time();
			}
			
			echo json_encode($resp);
		break;
		
		case 'chat':
			$chat = new Chat();
			$chat->de = $_SESSION['me']['codusuario'];
			$chat->codsala = $_SESSION['me']['codsala'];
			$chat->para = $_POST['para']['codusuario'];
			$chat->dtahr = time();
			$chat->msg = htmlentities($_POST['msg'], ENT_COMPAT, 'UTF-8');
			$chat->save();
		break;
		
		case 'sair':
			$user = new Usuario();
			$user->codusuario = $_SESSION['me']['codusuario'];
			$user->delete();
			
			session_destroy();
		break;
	}
	exit;
}
?>
<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>Chat</title>

	<script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jquery/1.7.1/jquery.min.js"></script>
	<script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jqueryui/1.8.17/jquery-ui.min.js"></script>
	<script type="text/javascript">
	var tpl
		, buddiesCt
		, chatTpl
		, updateInterval = 5 //em segundos
		, me = <?php echo json_encode($_SESSION['me']); ?>;
		
	$(function(){
		tpl = $('#tpl');
		buddiesCt = tpl.parent();
		tpl.remove();

		chatTpl = $('#chat-tpl');
		chatTpl.remove();

		updateChat();

		$('.sair').click(function(e){
			$.post('chat.php', {acao: 'sair'}, function(resp){
				location.href='index.php';
			});
			e.preventDefault();
			return false;
		});
	});

	function updateChat(){
		$.post('chat.php', {acao: 'update'}, function(response){
			var codes=[];
			
			$.each(response.buddies, function(idx, item){
				if($('#b-'+item.codusuario).length == 0){
					var div = tpl.clone();
					div.data('info', item)
						.attr('id', 'b-'+item.codusuario)
						.click(buddyClickHandler)
						.find('strong')
						.html(item.apelido)
						.parent()
						.appendTo(buddiesCt);
				}

				codes.push(item.codusuario);
			});
			
			$('.buddy').each(function(){
				var c=this.id.split('-')[1];
				if(codes.indexOf(c)==-1){
					$(this).remove();
					$('#p-'+c).remove();
				}
			});

			if(response.buddies.length==0){
				buddiesCt.html('<div class="ninguem">Ninguém além de vc</div>');
			} else {
				buddiesCt.find('.ninguem').remove();
			}
			
			$.each(response.msg, function(idx, msg){
				var info = $('#b-'+msg.de).data('info');
				var wnd = createChatWindow(info);
				addMessage(wnd, {apelido: info.apelido, msg:msg.msg});
			});

			setTimeout(updateChat, updateInterval * 1000);
			
		}, 'json');
	}

	function buddyClickHandler(e){
		createChatWindow($(this).data('info'));
	}

	function createChatWindow(who){
		if(who.codusuario == me.codusuario){
			alert('Tá sozinho??');
			return;
		}

		if($('#p-'+who.codusuario).length > 0){
			return $('#p-'+who.codusuario).show();
		}

		var tpl = chatTpl.clone();
		tpl.attr('id','p-'+who.codusuario)
			.data('info', who)
			.find('h1 span')
			.html(who.apelido)
			.parent().find('.close')
			.click(chatH1ClickHandler)
			.parent().parent()
			.find('textarea').keypress(chatTextareaKeyPressHandler)
			.parent()
			.draggable({
				handle: 'h1'
			})
			.appendTo(document.body);

		return tpl;
	}

	function chatH1ClickHandler(e){
		$(this).closest('.chat-tpl').hide();
	}

	function chatTextareaKeyPressHandler(e){
		if(e.keyCode == 13){
			var msg = this.value
				data = {
					acao: 'chat',
					para: $(this).closest('.chat-tpl').data('info'),
					msg: msg
				};
			
			this.value = '';
			addMessage($(this).parent(), {
				apelido: 'mim',
				msg: msg
			});
			

			$.post('chat.php', data, function(response){
				// console.log(response);
			});
			
			e.preventDefault();
			return false;
		}
	}

	function addMessage(wnd, msgInfo){
		var txt = wnd.find('.txt-area');
		txt.append('<p><strong>'+msgInfo.apelido+':</strong> '+msgInfo.msg+'</p>');
		txt[0].scrollTop = 100000000;
	}
	
	</script>

	<style type="text/css">
		* {
			font-family: Verdana;
			font-size: 11px;
		}
		.chat-tpl {
			font-family: Verdana;
			width: 170px;
			height: 200px;
			border: 1px solid black;
			padding: 1px;
			position: absolute;
			background-color: #FFFFFF;
		}
		.chat-tpl h1 {
			padding: 2px;
			font-size: 11px;
			margin: 0px;
			color: #FFFFFF;
			background-color: #003366;
		}
		.chat-tpl h1 .close {
			float: right;
			width: 15px;
			height: 15px;
			background-image: url(close.png);
			background-repeat: no-repeat;
			background-position: center center;
		}
		.chat-tpl .txt-area p {
			margin: 0px;
			padding: 0px;
		}
		.chat-tpl .txt-area {
			position: absolute;
			bottom: 39px;
			top: 20px;
			right: 1px;
			left: 1px;
			font-size: 11px;
			overflow: auto;
		}
		.chat-tpl textarea {
			font-family: Verdana;
			font-size: 10px;
			height: 30px;
			position: absolute;
			display: block;
			bottom: 2px;
			width: 164px;
		}
		#buddies .entrou_como{
			font-size: 9px;
			text-align:right;
		}
		#buddies .apelido, #buddies .apelido a {
			font-size: 9px;
			font-weight: bold;
			text-align:right;
			padding-bottom: 10px;
		}
		#buddies {
			width: 130px;
			position: absolute;
			right: 2px;
			top: 2px;
			bottom: 2px;
			overflow: auto;
			border: 1px solid #EFEFEF;
			padding: 2px;
		}
		#buddies h1 {
			margin: 0px;
			font-size: 14px;
		}
		.buddy {
			background-image: url(icon.png);
			background-repeat: no-repeat;
			background-position: 3px center;
			border: 1px solid #777777;
			background-color: #EFEFEF;
			margin-bottom: 3px;
			padding: 3px;
			padding-left: 20px;
			cursor: pointer;
		}
	</style>
</head>
<body>
	
	<div id="buddies">
		<div class="entrou_como">Entrou como</div>
		<div class="apelido"><?php echo $_SESSION['me']['apelido'];?> - <a href="#" class="sair">sair</a></div>
		
		<h1>Usuários online</h1>
		<div>
			<div id="tpl" class="buddy">
				<strong>nome</strong>
			</div>
		</div>
	</div>
	
	<div id="chat-tpl" class="chat-tpl">
		<h1>
			<span>Nome</span>
			<div class="close"></div>
		</h1>
		<div class="txt-area"></div>
		<textarea></textarea>
	</div>
	
</body>
</html>