<?php 

include 'config.php';

session_start();

// se ja estiver logado
if(!empty($_SESSION['me']['codusuario'])){
	$user = new Usuario();
	// se o usuario ainda existir no banco
	if( $user->get($_SESSION['me']['codusuario']) == 1 ){
		$user->ultimaAtividade = time();
		$user->save();
		
		// ja enviamos para o chat
		header('Location: chat.php');
		exit;
	}
}

// pegamos a lista de salas
$lista = new Sala();
$lista->order('nome')->find();
$salas = $lista->allToArray();

// vemos se o usuario informou um apelido
$apelido = empty($_POST['apelido']) ? '' : htmlentities(strip_tags($_POST['apelido']), ENT_COMPAT, 'UTF-8');

// mensagem de problemas
$msg = array();

// se enviou uma acao e for para entrar
if(!empty($_POST['acao']) && $_POST['acao'] == 'entrar'){
	
	// se nao informou o apelido
	if(empty($apelido)) $msg[] = 'Informe um apelido';
	// se nao informou a sala
	if(empty($_POST['codsala'])) $msg[] = 'Informe uma sala';
	// limpa usuarios inativos
	Usuario::limparUsuariosInativos();
	// cria um novo usuario
	$user = new Usuario();
	// se informou o apelido
	if(!empty($apelido)){
		// se ja estao usando este apelido
		if( $user->get('apelido', $apelido) > 0 ){
			$msg[] = 'Já existe um usuário com este apelido';
		}
	}
	
	// se nao houve erros
	if(empty($msg)){
		// grava o usuario no banco
		$user->reset();
		$user->apelido = $apelido;
		$user->codsala = $_POST['codsala'];
		$user->ultimaAtividade = time();
		$user->save();
		
		// grava o usuario na sessao
		$_SESSION['me'] = $user->toArray();
		
		// envia para a tela de chat
		header('Location: chat.php');
		exit;
	}
}
?>
<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>Chat</title>
<style type="text/css">
* {
	margin: 0px;
	padding: 0px;
	font-family: Verdana, Geneva, Arial, Helvetica, sans-serif;
	font-size: 11px;
	font-weight: normal;
	font-style: normal;
}
.login-box {
	margin-top: 200px;
	width: 450px;
	margin-left: auto;
	margin-right: auto;
	border: 1px solid #999999;
	padding: 5px;
	border-radius: 5px;
}
.login-box p {
	clear: both;
	padding-bottom: 5px;
}
.login-box label {
	display: block;
	float: left;
	width: 120px;
	padding-top: 2px;
	padding-right: 10px;
	text-align: right;
}
.login-box #btnEntrar {
	padding: 4px;
}
.login-box h1 {
	border-radius: 5px;
	font-size: 14px;
	font-weight: bold;
	color: #555555;
	margin-bottom: 10px;
	background-color: #EFEFEF;
	padding: 4px 4px 4px 25px;
	background-image: url("http://www.iconfinder.com/ajax/download/png/?id=36090&s=16");
	background-position: 3px center;
	background-repeat: no-repeat;
}
.login-box .erro{
	padding: 4px;
	background-color: #FFFF55;
	color: #FF0000;
	font-weight: bold;
	margin-bottom: 10px;
}
</style>
</head>
<body>
	<form class="login-box" method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>">
		<h1>Entrar no Chat</h1>
		<?php 
		if(!empty($msg)){
			echo '<div class="erro">', implode('<br />', $msg), '</div>';
		}
		?>
		<p>
			<label for="">Escolha um apelido</label>
			<input type="text" id="apelido" name="apelido" value="<?php echo $apelido; ?>" />
		</p>
		<p>
			<label for="">Escolha uma sala</label>
			<select id="codsala" name="codsala">
				<option value="">---</option>
				<?php 
				$salaEscolhida = empty($_POST['codsala']) ? 0 : $_POST['codsala'];
				foreach($salas as $item){
					printf('<option value="%d" %s>%s</option>'
						, $item['codsala']
						, $item['codsala'] == $salaEscolhida ? 'selected="selected"' : ''
						, $item['nome']
					);
				}
				?>
			</select>
			<input type="submit" id="btnEntrar" name="btnEntrar" value="Efetuar Login" />
			<input type="hidden" id="acao" name="acao" value="entrar" />
		</p>
	</form>
</body>
</html>